#include <zephyr.h>
#include <sys/reboot.h>
#include <device.h>
#include <string.h>
#include <drivers/flash.h>
#include <storage/flash_map.h>
#include <fs/nvs.h>
#include <bluetooth/bluetooth.h>

static struct nvs_fs fs;

#define STORAGE_NODE DT_NODE_BY_FIXED_PARTITION_LABEL(storage)
#define FLASH_NODE DT_MTD_FROM_FIXED_PARTITION(STORAGE_NODE)
#define ID_DATA1 1
#define ID_DATA2 2
#define ID_DATA3 3

void check_return(int rc){

}

void main(void)
{

	int rc = 0;
	char buf[16];
	char data1[] = "data1";
	char data2[] ="data2";
	char data3[] ="data3";
	struct flash_pages_info info;
	const struct device *flash_dev;

	/* define the nvs file system by settings with:
	 *	sector_size equal to the pagesize,
	 *	3 sectors
	 *	starting at FLASH_AREA_OFFSET(storage)
	 */
	flash_dev = DEVICE_DT_GET(FLASH_NODE);
	if (!device_is_ready(flash_dev)) {
		printk("Flash device %s is not ready\n", flash_dev->name);
		return;
	}
	fs.offset = FLASH_AREA_OFFSET(storage);
	rc = flash_get_page_info_by_offs(flash_dev, fs.offset, &info);
	if (rc) {
		printk("Unable to get page info\n");
		return;
	}
	fs.sector_size = info.size;
	fs.sector_count = 3U;
	printk("Before nvs_init() from app\n");
	rc = nvs_init(&fs, flash_dev->name);
	if (rc) {
		printk("Flash Init failed\n");
		return;
	}

	rc = bt_enable(NULL);
	if (rc) {
		printk("Enable bluetooth failed\n");
	}else{
		printk("Enable bluetooth sucess!\n");
	}

	(void)nvs_write(&fs, ID_DATA1, &data1, strlen(data1) + 1);
	(void)nvs_write(&fs, ID_DATA2, &data2, strlen(data2) + 1);
	(void)nvs_write(&fs, ID_DATA3, &data3, strlen(data3) + 1);

	rc = nvs_read(&fs, ID_DATA1, &buf, sizeof(buf));
	if (rc > 0) {
		printk("Item at id %d was found: %s\n",ID_DATA1, buf);
	}else{
		printk("Item at id %d  was not found\n", ID_DATA1);
	}
	rc = nvs_read(&fs, ID_DATA2, &buf, sizeof(buf));
	if (rc > 0) {
		printk("Item at id %d was found: %s\n",ID_DATA2, buf);
	}else{
		printk("Item at id %d  was not found\n", ID_DATA2);
	}
	rc = nvs_read(&fs, ID_DATA3, &buf, sizeof(buf));
	if (rc > 0) {
		printk("Item at id %d was found: %s\n",ID_DATA3, buf);
	}else{
		printk("Item at id %d  was not found\n", ID_DATA3);
	}
}
